
dim shared font(0 to 4, 0 to 4) as uinteger = {_
  {&h03FABCBA, &h8077FCFF, &h0073FCFF, &h8053FEFF, &h02C6BCBB},_
  {&h420FC17F, &h81803000, &h000684B3, &h82E00000, &h42154B5E},_
  {&h120FC37F, &hF0080500, &h73CEB5B3, &hE1080100, &h1B3D4B5E},_
  {&h220FC77F, &h83801000, &h000780C3, &h80E02400, &h22154B5E},_
  {&h03FC32B0, &h8073F28F, &h007172C9, &h805772CF, &h02C23C91}_
}

type tDotMatrix
  as integer scale, length, color1, color2, color3, cols, rows, left_, top
  declare sub Initialize(_
    as integer,_
    as integer,_
    as integer,_
    as integer,_
    as integer,_
    as integer,_
    as integer)
  declare function ImageWidth as integer
  declare function ImageHeight as integer
  declare sub ClearMatrix
  declare sub DrawCharacter(as integer, as integer, as integer)
  declare sub DrawString(as string)
end type

sub tDotMatrix.Initialize(_
  aScale as integer,_
  aLength as integer,_
  aColor1 as integer,_
  aColor2 as integer,_
  aColor3 as integer,_
  aLeft as integer,_
  aTop as integer)
  scale = aScale
  length = aLength
  cols = length * 5 + length + 1
  rows = 1 * 5 + 2
  color1 = aColor1
  color2 = aColor2
  color3 = aColor3
  left_ = aLeft
  top = aTop
end sub

function tDotMatrix.ImageWidth as integer
  function = (2 * cols + 1) * scale + 1
end function

function tDotMatrix.ImageHeight as integer
  function = (2 * rows + 1) * scale  + 1
end function

sub tDotMatrix.ClearMatrix
  dim as integer xf, yf
  line(left_, top)-(left_ + ImageWidth - 1, top + ImageHeight - 1), color1, bf
  for x as integer = 0 to cols - 1
    for y as integer = 0 to rows - 1
      xf = 2 * scale * x + scale + left_
      yf = 2 * scale * y + scale + top
      line(xf, yf)-(xf + scale, yf + scale), color2, bf
    next y
  next x
end sub

sub tDotMatrix.DrawCharacter(i as integer, ax as integer, ay as integer)
  dim as integer xf, yf
  if (i < 0) or (i > 31) then i = 0
  for x as integer = 0 to 4
    for y as integer = 0 to 4
      if (font(x, y) and (1 shl i)) > 0 then
        xf = 2 * scale * (ax + x) + scale + left_
        yf = 2 * scale * (ay + y) + scale + top
        line(xf, yf)-(xf + scale, yf + scale), color3, bf
      end if
    next y
  next x
end sub

sub tDotMatrix.DrawString(s as string)
  const chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ .!()="
  dim index as integer
  if len(s) > length then s = left(s, length)
  for i as integer = 0 to len(s) - 1
    index = instr(chars, chr(s[i])) - 1
    DrawCharacter(index, 5 * i + i + 1, 1)
  next i
end sub
