
' Frogger revisited
' http://www.freebasic.net/forum/viewtopic.php?f=8&t=18005

#include "fbgfx.bi"
#include "inc\Colors.bi"
#include "inc\fbsound.bi"
#libpath "lib\win32"
#include "dotmatrix.bas"
#include "rotozoom.bas"

using fb

type sprite
  x  as integer
  y  as integer
  dx as integer
  dy as integer
  w  as integer
  h  as integer
  sp as integer ' speed
  a  as single  ' angle
  ta as integer ' target angle
  j  as single  ' jump
end type

declare function Collision(s1 as sprite, s2 as sprite) as integer

screenres 372, 416, 32,, 4
windowtitle ""

dim as FB.Image ptr iFrog1 = imagecreate( 21,  23, 0)
dim as FB.Image ptr iFrog2 = imagecreate( 21,  23, 0)
dim as FB.Image ptr iCar1  = imagecreate( 40,  20, 0)
dim as FB.Image ptr iCar2  = imagecreate( 40,  20, 0)
dim as FB.Image ptr iCroc1 = imagecreate( 80,  20, 0)
dim as FB.Image ptr iCroc2 = imagecreate( 80,  20, 0)
dim as FB.Image ptr iBkgrd = imagecreate(372, 416, 0)

dim as tDotMatrix m1, m2

dim as string s
dim as integer i, j, k

for j = 0 to 22
  read s
  for i = 0 to 20
    select case mid(s, i + 1, 1)
      case "P" : pset(i, j), &HFFFF00FF
      case "B" : pset(i, j), &HFF000000
      case "G" : pset(i, j), LawnGreen
      case "Y" : pset(i, j), Snow
    end select
  next i
next j

get(0, 0)-(20, 22), iFrog1

for j = 0 to 22
  for i = 0 to 20
    select case point(i, j)
      case LawnGreen : pset(i, j), LightGray
      case Snow : pset(i, j), WhiteSmoke
    end select
  next i
next j

get(0, 0)-(20, 22), iFrog2

for j = 0 to 19
  read s
  for i = 0 to 39
    select case mid(s, i + 1, 1)
      case "P" : pset(i, j), GrayAsparagus
      case "B" : pset(i, j), Black
      case "W" : pset(i, j), PowderBlue
      case "R" : pset(i, j), SteelBlue
    end select
  next i
next j

get(0, 0)-(39, 19), iCar1

for j = 0 to 19
  for i = 0 to 19
    k = point(i, j)
    pset(i, j), point(39 - i, j)
    pset(39 - i, j), k
  next i
next j

get(0, 0)-(39, 19), iCar2

for i = 0 to 79
  read s
  for j = 0 to 19
    select case mid(s, j + 1, 1)
      case "P" : pset(i, j), MediumSeaGreen
      case "B" : pset(i, j), Black
      case "G" : pset(i, j), OliveDrab
      case "Y" : pset(i, j), WhiteSmoke
      case "X" : pset(i, j), SeaGreen
    end select
  next j
next i

get(0, 0)-(79, 19), iCroc1

for j = 0 to 19
  for i = 0 to 39
    k = point(i, j)
    pset(i, j), point(79 - i, j)
    pset(79 - i, j), k
  next i
next j

get(0, 0)-(79, 19), iCroc2

line(0,000)-(371,031), DarkGreen, bf
line(0,032)-(371,063), DarkGreen, bf
line(0,064)-(371,191), MediumSeaGreen, bf
line(0,192)-(371,223), DarkGreen, bf
line(0,224)-(371,351), GrayAsparagus, bf
line(0,256)-(371,256), LightGray,, &b1111111100000000
line(0,288)-(371,288), LightGray
line(0,320)-(371,320), LightGray,, &b1111111100000000
line(0,352)-(371,383), DarkGreen, bf
line(0,384)-(371,415), DarkGreen, bf

m1.Initialize(2, 15, &h202020, &h505050, &h909090, 3, 0)
m2.Initialize(2, 15, &h202020, &h505050, &h909090, 3, 384)
m1.ClearMatrix
m2.ClearMatrix
m1.DrawString("    FROGGER    ")

get(0,0)-(371, 415), iBkgrd

dim as string reply
dim as integer chosenLog, hit
dim as double instant
dim as sprite sFrog, sCar(1 to 4), sCroc(1 to 4)
dim as integer hWaveStart, hWaveHop, hWaveCroak, hWaveFinish

fbs_Init()
fbs_Load_WAVfile("wav\Start.wav", @hWaveStart)
fbs_Load_WAVfile("wav\Hop.wav", @hWaveHop)
fbs_Load_WAVfile("wav\Croak.wav", @hWaveCroak)
fbs_Load_WAVfile("wav\Finish.wav", @hWaveFinish)

do
  if fbs_Get_PlayingSounds() = 0  then
    fbs_Play_Wave(hWaveStart)
  end if
  sFrog.x = 170
  sFrog.y = 357
  sFrog.w = 21
  sFrog.h = 23
  sFrog.sp = 32
  sCar(1).x = 0
  sCar(1).y = 230
  sCar(1).dx = 1
  sCar(1).dy = 0
  sCar(1).w = 40
  sCar(1).h = 20
  sCar(2).x = 300
  sCar(2).y = 262
  sCar(2).dx = 1
  sCar(2).dy = 0
  sCar(2).w = 40
  sCar(2).h = 20
  sCar(3).x = 150
  sCar(3).y = 294
  sCar(3).dx = 1
  sCar(3).dy = 0
  sCar(3).w = 40
  sCar(3).h = 20
  sCar(4).x = 30
  sCar(4).y = 326
  sCar(4).dx = 1
  sCar(4).dy = 0
  sCar(4).w = 40
  sCar(4).h = 20
  sCroc(1).x = 0
  sCroc(1).y = 72
  sCroc(1).dx = 1
  sCroc(1).dy = 0
  sCroc(1).w = 60
  sCroc(1).h = 20
  sCroc(2).x = 280
  sCroc(2).y = 104
  sCroc(2).dx = 1
  sCroc(2).dy = 0
  sCroc(2).w = 60
  sCroc(2).h = 20
  sCroc(3).x = 150
  sCroc(3).y = 136
  sCroc(3).dx = 1
  sCroc(3).dy = 0
  sCroc(3).w = 60
  sCroc(3).h = 20
  sCroc(4).x = 30
  sCroc(4).y = 168
  sCroc(4).dx = 1
  sCroc(4).dy = 0
  sCroc(4).w = 60
  sCroc(4).h = 20
  reply = ""
  chosenLog = 0
  instant = 0
  i = 0 
  j = 0
  k = 0
  do
    screenlock()
    put(0, 0), iBkgrd, pset
    for i as integer = 1 to 4
      if sCroc(i).dx < 0 then
        put(sCroc(i).x, sCroc(i).y), iCroc2, trans
      else
        put(sCroc(i).x, sCroc(i).y), iCroc1, trans
      end if
    next i
    if sFrog.sp = 0 then
      rotozoom(, iFrog2, sFrog.x + iFrog2 -> width \ 2, sFrog.y + iFrog2 -> Height \ 2, int(sFrog.a), sFrog.j, sFrog.j)
    else
      rotozoom(, iFrog1, sFrog.x + iFrog1 -> width \ 2, sFrog.y + iFrog1 -> Height \ 2, int(sFrog.a), sFrog.j, sFrog.j)
    end if
    for i as integer = 1 to 4
      if sCar(i).dx < 0 then
        put(sCar(i).x, sCar(i).y), iCar2, trans
      else
        put(sCar(i).x, sCar(i).y), iCar1, trans
      end if
    next i
    if sFrog.sp = 0 then
      m2.DrawString("   FROG DEAD   ")
      if i < 2 then i += 1
      if i = 1 then fbs_Play_Wave(hWaveCroak)
    end if
    if sFrog.y < 64 then
      m2.DrawString("   FROG HOME   ")
      if j < 2 then j += 1
      if j = 1 then fbs_Play_Wave(hWaveFinish)
    end if
    screenunlock()

    for i as integer = 1 to 4
      sCar(i).x = sCar(i).x + sCar(i).dx
    next i
    for i as integer = 1 to 4
      sCroc(i).x = sCroc(i).x + sCroc(i).dx
      if chosenLog = i then
        sFrog.x = sFrog.x + sCroc(i).dx
      end if
    next i
    for i as integer = 1 to 4
      if sCar(i).x < 1 or sCar(i).x > 330 then sCar(i).dx = - sCar(i).dx
    next i
    for i as integer = 1 to 4
      if sCroc(i).x < 1 or sCroc(i).x > 290 then sCroc(i).dx = - sCroc(i).dx
    next i
    sFrog.a += (sFrog.ta - sFrog.a) / 5
    sFrog.j -= .1
    if sFrog.j < 1 then sFrog.j = 1

    if timer > (instant + 0.25) then
      if multikey(SC_SPACE) then reply = "y"
      
      if multikey(SC_ESCAPE) then reply = "x"
      if inkey = chr(255) & "k" then reply = "x"
      
      if (sFrog.y > 63) and (sFrog.sp <> 0) then
        if multikey(SC_DOWN) andalso (sFrog.y < 352) then
          sFrog.y = sFrog.y + sFrog.sp
          sFrog.ta = 180
          sFrog.j = 1.5
          instant = timer
          chosenLog = 0
          fbs_Play_Wave(hWaveHop)
        end if
        if multikey(SC_UP)  then
          if sFrog.ta = 270 then sFrog.a = -90
          sFrog.y = sFrog.y - sFrog.sp
          sFrog.ta = 0
          sFrog.j = 1.5
          instant = timer
          chosenLog = 0
          fbs_Play_Wave(hWaveHop)
        end if
        if multikey(SC_RIGHT) andalso sFrog.x < 302 then
          if sFrog.ta = 0 then sFrog.a = 360
          sFrog.x = sFrog.x + sFrog.sp
          sFrog.ta = 270
          sFrog.j = 1.5
          instant = timer
          chosenLog = 0
          fbs_Play_Wave(hWaveHop)
        end if
        if multikey(SC_LEFT) andalso  sFrog.x > 10  then
          sFrog.x = sFrog.x - sFrog.sp
          sFrog.ta = 90
          sFrog.j = 1.5
          instant = timer
          chosenLog = 0
          fbs_Play_Wave(hWaveHop)
        end if
      end if
    end if

    if (sFrog.y >= 224) and (sFrog.y < 352) then
      hit = 0
      for i as integer = 1 to 4
        if hit = 0 then hit = Collision(sFrog, sCar(i))
      next i
      if hit <> 0 then sFrog.sp = 0
    end if

    if (sFrog.y >= 64) and (sFrog.y < 192) then
      hit = 0
      for i as integer = 1 to 4
        hit = Collision(sFrog, sCroc(i))
        if (hit <> 0) and (chosenLog = 0) and (sFrog.sp <> 0) then chosenLog = i
      next i
      if  chosenLog = 0 then
        'print "MISSED LOG"
        sFrog.sp = 0
      end if
    end if

    sleep 10, 1
  loop while (reply <> "y") and (reply <> "x")
loop while reply = "y"

end

function Collision(s1 as sprite, s2 as sprite) as integer
  if (s1.x >= s2.x) and (s1.x < s2.x + s2.w) then
    if (s1.y >= s2.y) and (s1.y < s2.y + s2.h) then return 1
    if (s1.y + s1.h > s2.y) and (s1.y + s1.h <= s2.y + s2.h) then return 2
    if (s1.y < s2.y) and (s1.y + s1.h > s2.y + s2.h) then return 3
  end if
  if (s1.x + s1.w > s2.x) and (s1.x + s1.w <= s2.x + s2.w) then
    if (s1.y >= s2.y) and (s1.y < s2.y + s2.h) then return 4
    if (s1.y + s1.h > s2.y) and (s1.y + s1.h <= s2.y + s2.h) then return 5
    if (s1.y < s2.y) and (s1.y + s1.h > s2.y + s2.h) then return 6
  end if
  if (s1.x < s2.x) and (s1.x + s1.w > s2.x + s2.w) then
    if (s1.y >= s2.y) and (s1.y < s2.y + s2.h) then return 7
    if (s1.y + s1.h > s2.y) and (s1.y + s1.h <= s2.y + s2.h) then return 8
    if (s1.y < s2.y) and (s1.y + s1.h > s2.y + s2.h) then return 9
  end if
  function = 0
end function

data "PPPPPPPPPBBBPPPPPPPPP"
data "PPPPPBBBBGGGBBBBPPPPP"
data "PPPPBYBBYBGBYBBYBPPPP"
data "PPPPBYBBYBGBYBBYBPPPP"
data "PBBPBYYYYBGBYYYYBPBBP"
data "BGGBPBBBBGGGBBBBPBGGB"
data "PBGGBBGGGGGGGGGBBGGBP"
data "BGGGGBBGGGBGGGBBGGGGB"
data "PBGGGBBBBGBGBBBBGGGBP"
data "BGGGGGBGGGBGGGBGGGGGB"
data "PBBBGBGGGGGGGGGBGBBBP"
data "PPPPBBGGGGBGGGGBBPPPP"
data "PPPPBGGGGGBGGGGGBPPPP"
data "PPPPBGGGGGBGGGGGBPPPP"
data "PBBBBGGGGGBGGGGGBBBBP"
data "PBGGGBGGGGBGGGGBGGGBP"
data "PBGGGGBGGGBGGGBGGGGBP"
data "PBBGGGBGGGBGGGBGGGBBP"
data "PPBGBGGBGGBGGBGGBGBPP"
data "PBBBGGGBGGGGGBGGGBBBP"
data "PBGGGBBGBGGGBGBBGGGBP"
data "PBBBGGBBBGGGBBBGGBBBP"
data "PPPPBBBPPBBBPPBBBPPPP"

data "PPPPPBBBBBBBBBBBBBBBBBBBBBPPPPPPPPPPPPPP"
data "PPPPBRRRRRRRRRRRRRRRRRRRBWBPPPPPPPPPPPPP"
data "PPPBBRRRRRRRRRRRRRRRRRRRBWWBBPPPPPPPPPPP"
data "PPBWBRRRRRRRRRRRRRRRRRRRBWWWWBPPPPPPPPPP"
data "PBBWBRRRRRRRRRRRRRRRRRRRBWWWWWBBBBBBBBBB"
data "BRBWBRRRRRRRRRRRRRRRRRRRBWWWWWWBRRRRRRRB"
data "BRBWBRRRRRRRRRRRRRRRRRRRBWWWWWWBRRRRRRRB"
data "BRBWBBBBBBBBBBBBBBBBBBBBBBWWWWWBRRRRRRRB"
data "BRBWBWWWWWWWWWWBWWWWWWWWBBWWWWWBRRRRRRRB"
data "BRBWBWWWWWWWWWWBWWWWWWWWBWBWWWWBRRRRRRRB"
data "BRBWBWWWWWWWWWWBWWWWWWWWBWWBBWWBRRRRRRRB"
data "BRBWBWWWWWWWWWWBWWWWWWWWBWWWWBWBRRRRRRRB"
data "BRBWBWWWWWWWWWWBWWWWWWWWBWWWWWBBRRRRRRRB"
data "BRBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB"
data "BRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRB"
data "BRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRB"
data "BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB"
data "PBBBBBBBBPPPPPPPPPPPPPPPPPPPPPPBBBBBBBBB"
data "PPBBBBBBPPPPPPPPPPPPPPPPPPPPPPPPBBBBBBBP"
data "PPPBBBBPPPPPPPPPPPPPPPPPPPPPPPPPPBBBBBPP"

data "PPPPPPPPPPPPPPBBXXBX"
data "PPPPPPPPPPPPPBBGXXBP"
data "PPPPPPPPPPPPPBBGGXBP"
data "PPPPPPPPPPPPPPBGGXBP"
data "PPPPPPPPPPPPPBBGXXBX"
data "PPPPPPPPPPPPPBBGXXBP"
data "PPPPPPPPPPPPPPBGXGPP"
data "PPPPPPPPPPPPPBBGXXPX"
data "PPPPPPPPPPPPBBGGXXGX"
data "PPPPPPPPPPPPPBBGXXBX"
data "PPPPPPPPPPPPPPBGXXXX"
data "PPPPPPPPPPPPBBBGGXXP"
data "PPPPPPPPPPPPBGGGGXBP"
data "PPPPPPPPPPPPBBGGGXBP"
data "PPPPPPPPPPPPPBBGGXBP"
data "PPPPPPPPPPPPPBGGGXBP"
data "PPPPPPPPPPPPBBGGGGXP"
data "PPPPPPPPPPPPBBGGBGXB"
data "PPPPPPPPPPPPPBGBBGXX"
data "PPPPPPPPPPPPBBGBGGBX"
data "PPPPPPPPPPPPBGGGGGBX"
data "PPPPPPPPPPPPBGGBGGPX"
data "PPPPPPPPPPPBBGGBGGGX"
data "PPPPPPPPPPBBGGGGGGGX"
data "PPPPPPPPPPBGGGGGGXGP"
data "PPPPPPPPPPBGGGGGGXGP"
data "PPPPPPPPPPBGGGGBGXGP"
data "PPPPPPPPPBBGGGGBGXGP"
data "PPPPPPPPBBGGGGGBGXGP"
data "PPPPPPPPBGGGGGBBGXGP"
data "PPPPPPPPBGGGGGBGGXGX"
data "PPPPPPPBBGGGGGBGGGGX"
data "PPPPPPBBGGGBGGBBGGGX"
data "PPPPPPBGGGBBGGGBGGGP"
data "PPPPPPBBGGGBGGGBGGGP"
data "PPPPPPPBGGBBGGGBGBGP"
data "PPPPPPBBGGBBGGGBGBGP"
data "PPPPPBBGGGGBGGBGBBGX"
data "PPPPPBGGGGGGGGBGBGGX"
data "PPPPPBBGGGGGGGBGBGGX"
data "PPPPPPBGGGGGGGBBGGBX"
data "PPPPPBBGGGBGGGBBGGBX"
data "PPPPPBGGGGGGGGBGGGBX"
data "PPPPBBGGGGGGGBBGGGXP"
data "PPPPBBGGGGGGGBGGGGXP"
data "PPPPPBGGGGGGBBGGGGXP"
data "PPPPPBGGGBGGBGGGGGXP"
data "PPPPPBBGGGGGBGGGGGXP"
data "PPPPPPBGGGGGGGBGGGPP"
data "PPPPPBBGGGGGGBBGGGPX"
data "PPPPBBGGGBGGGGBGGGPX"
data "PPPPBBGGBBGGGGBGBGXX"
data "PPPPPBGGBGGGGBBGGBXX"
data "PPPPPBGGGGGGGBBGGBXX"
data "PPPPPBGGGGGGGBGGGBXX"
data "PPPPBBGGGBGBGBGGGBXX"
data "PPPPBGGGGBGBGBGGGXXX"
data "PPBBBGGGGGGGGBBGGXXX"
data "PBGGGGBBGGGGGBBGGXPX"
data "BGYYYYYBGGGGGGBGGXPX"
data "BGYBBYYBGGGGGGBGGGPX"
data "BGYBBYYBGGGGGGBGGGXX"
data "PBGGGBBGGGGGGGBBGGXX"
data "PPBBBBBBGGGGGGBBBGXX"
data "PPPPPPPBGGGGGBGBBGXX"
data "PPPPPPPPBGGGGBBBBGXX"
data "PPPPPPPPBGGGGBBBGGXX"
data "PPPPPPPPPBGGGGBBGGPP"
data "PPPPPPPPPPBGGGBBGGXP"
data "PPPPPPPPPPBGGGBBGGXP"
data "PPPPPPPPPPBGGGBBGGXX"
data "PPPPPPPPPPBGGGBBGGXP"
data "PPPPPPPPPPBGGGBBGXXP"
data "PPPPPPPPPPBGGGBBGXXP"
data "PPPPPPPPPBBGGGBBXXXP"
data "PPPPPPPPBGGGGGBBXXPX"
data "PPPPPPPBGBBGGGBBXXPX"
data "PPPPPPPBGBBBGGBBXXPX"
data "PPPPPPPPBGGGGBBBXXPX"
data "PPPPPPPPPBBBBBBXXPPX"
