
' Dr_D

#include "fbgfx.bi"
using fb

screenres 640,480,32

const as double pi = 3.1415926, pi_180 = pi / 180

type sprite
    x  as integer
    y  as integer
    dx as integer
    dy as integer
    w  as integer
    h  as integer
    speed as integer
    angle   as single
    target_angle as integer
    jump as single
end type


sub rotozoom( byref dst as FB.IMAGE ptr = 0, byref src as const FB.IMAGE ptr, byval positx as integer, byval posity as integer, byref angle as integer, byref zoomx as single, byref zoomy as single = 0, byval transcol as uinteger  = &hffff00ff, byval offsetx as integer = 0, byref offsety as integer = 0 )
    
    'Rotozoom for 32-bit FB.Image by Dr_D(Dave Stanley) and yetifoot(Simon Nash)
    'No warranty implied... use at your own risk ;) 
    
    static as integer mx, my, col, nx, ny
    static as single nxtc, nxts, nytc, nyts
    static as single tcdzx, tcdzy, tsdzx, tsdzy
    static as integer sw2, sh2, dw, dh
    static as single tc, ts, _mx, _my
    static as uinteger ptr dstptr, srcptr, odstptr
    static as integer xput, yput, startx, endx, starty, endy
    static as integer x(3), y(3), xa, xb, ya, yb, lx, ly
    static as ubyte ptr srcbyteptr, dstbyteptr
    static as integer dstpitch, srcpitch, srcbpp, dstbpp, srcwidth, srcheight
    
    if zoomx = 0 then exit sub
    if zoomy = 0 then zoomy = zoomx
    if src = 0 then exit sub

    if dst = 0 then
        dstptr = screenptr
        odstptr = dstptr
        screeninfo dw,dh,,,dstpitch
    else
        dstptr = cast( uinteger ptr, dst + 1 )
        odstptr = cast( uinteger ptr, dst + 1 )
        dw = dst->width
        dh = dst->height
        dstbpp = dst->bpp
        dstpitch = dst->pitch
    end if
    
    srcptr = cast( uinteger ptr, src + 1 )
    srcbyteptr = cast( ubyte ptr, srcptr )
    dstbyteptr = cast( ubyte ptr, dstptr )
    
    sw2 = src->width\2
    sh2 = src->height\2
    srcbpp = src->bpp
    srcpitch = src->pitch
    srcwidth = src->width
    srcheight = src->height
    
    tc = cos( angle * pi_180 )
    ts = sin( angle * pi_180 )
    tcdzx = tc/zoomx
    tcdzy = tc/zoomy
    tsdzx = ts/zoomx
    tsdzy = ts/zoomy
    
    xa = sw2 * tc * zoomx + sh2  * ts * zoomx
    ya = sh2 * tc * zoomy - sw2  * ts * zoomy
    
    xb = sh2 * ts * zoomx - sw2  * tc * zoomx
    yb = sw2 * ts * zoomy + sh2  * tc * zoomy

    dim as integer centerx = -(offsetx*(tc*zoomx) + offsety*(ts*zoomx)) + offsetx
    dim as integer centery = -(offsety*(tc*zoomy) - offsetx*(ts*zoomy)) + offsety

    x(0) = sw2-xa
    x(1) = sw2+xa
    x(2) = sw2-xb
    x(3) = sw2+xb
    y(0) = sh2-ya
    y(1) = sh2+ya
    y(2) = sh2-yb
    y(3) = sh2+yb
    
    for i as integer = 0 to 3
        for j as integer = i to 3
            if x(i)>=x(j) then
                swap x(i), x(j)
            end if
        next
    next
    startx = x(0)
    endx = x(3)
    
    for i as integer = 0 to 3
        for j as integer = i to 3
            if y(i)>=y(j) then
                swap y(i), y(j)
            end if
        next
    next
    starty = y(0)
    endy = y(3)
    
    positx-=sw2
    posity-=sh2
    positx+=centerx
    posity+=centery
    if posity+starty<0 then starty = -posity
    if positx+startx<0 then startx = -positx
    if posity+endy<0 then endy = -posity
    if positx+endx<0 then endx = -positx
    
    if positx+startx>(dw-1) then startx = (dw-1)-positx
    if posity+starty>(dh-1) then starty = (dh-1)-posity
    if positx+endx>(dw-1) then endx = (dw-1)-positx
    if posity+endy>(dh-1) then endy = (dh-1)-posity
    if startx = endx or starty = endy then exit sub
    
    
    xput = (startx + positx) * 4
    yput = starty + posity
    ny = starty - sh2
    nx = startx - sw2
    nxtc = (nx * tcdzx)
    nxts = (nx * tsdzx)
    nytc = (ny * tcdzy)
    nyts = (ny * tsdzy)
    dstptr += dstpitch * yput \ 4
    
   dim as integer y_draw_len = (endy - starty) + 1
   dim as integer x_draw_len = (endx - startx) + 1
    
    
    'and we're off!
    asm
        mov edx, dword ptr [y_draw_len]
        
        test edx, edx ' 0?
        jz y_end      ' nothing to do here
        
        fld dword ptr[tcdzy]
        fld dword ptr[tsdzy]
        fld dword ptr [tcdzx]
        fld dword ptr [tsdzx]
        
        y_inner:
        
        fld dword ptr[nxtc]     'st(0) = nxtc, st(1) = tsdzx, st(2) = tcdzx, st(3) = tsdzy, st(4) = tcdzy
        fsub dword ptr[nyts]    'nxtc-nyts
        fiadd dword ptr[sw2]    'nxtc-nyts+sw2
        
        fld dword ptr[nxts]     'st(0) = nxts, st(1) = tsdzx, st(2) = tcdzx, st(3) = tsdzy, st(4) = tcdzy
        fadd dword ptr[nytc]    'nytc+nxts
        fiadd dword ptr[sh2]    'nxts+nytc+sh2
        'fpu stack returns to: st(0) = tsdzx, st(1) = tcdzx, st(2) = tsdzy, st(3) = tcdzy 
        
        mov ebx, [xput]
        add ebx, [dstptr]
        
        mov ecx, dword ptr [x_draw_len]
        
        test ecx, ecx ' 0?
        jz x_end      ' nothing to do here
        
        x_inner:
        
        fist dword ptr [my] ' my = _my
        
        fld st(1)           ' mx = _mx
        fistp dword ptr [mx]
        
        mov esi, dword ptr [mx]         ' esi = mx
        mov edi, dword ptr [my]         ' edi = my
        
        ' bounds checking
        test esi, esi       'mx<0?
        js no_draw          
        'mov esi, 0
        
        test edi, edi
        'mov edi, 0
        js no_draw          'my<0?

        cmp esi, dword ptr [srcwidth]   ' mx >= width?
        jge no_draw
        cmp edi, dword ptr [srcheight]  ' my >= height?
        jge no_draw
        
        ' calculate position in src buffer
        mov eax, dword ptr [srcbyteptr] ' eax = srcbyteptr
        imul edi, dword ptr [srcpitch]  ' edi = my * srcpitch
        add eax, edi
        shl esi, 2
        ' eax becomes src pixel color
        mov eax, dword ptr [eax+esi]
        cmp eax, [transcol]
        je no_draw
        
        ' draw pixel
        mov dword ptr [ebx], eax
        no_draw:
        
        fld st(3)
        faddp st(2), st(0) ' _mx += tcdzx
        fadd st(0), st(2) ' _my += tsdzx
        
        ' increment the output pointer
        add ebx, 4
        
        ' increment the x loop
        dec ecx
        jnz x_inner
        
        x_end:
        
        fstp dword ptr [_my]
        fstp dword ptr [_mx]
        
        'st(0) = tsdzx, st(1) = tcdzx, st(2) = tsdzy, st(3) = tcdzy
        'nytc += tcdzy
        fld dword ptr[nytc]
        fadd st(0), st(4)
        fstp dword ptr[nytc]
        
        'st(0) = tsdzx, st(1) = tcdzx, st(2) = tsdzy, st(3) = tcdzy
        'nyts+=tsdzy
        fld dword ptr[nyts]
        fadd st(0), st(3) 
        fstp dword ptr[nyts]
        
        'dstptr += dst->pitch
        mov eax, dword ptr [dstpitch]
        add dword ptr [dstptr], eax
        
        dec edx
        jnz y_inner
        
        y_end:
        
        finit
    end asm
    
end sub


function scollision(s1 as sprite, s2 as sprite) as integer
       
    dim as integer hit
    hit = 0

    if s1.x >= s2.x and s1.x <= s2.x+s2.w then
        if s1.y >= s2.y and s1.y <= s2.y + s2.h then
            hit = 1
        end if
        if s1.y + s1.h >= s2.y and s1.y + s1.h <= s2.y+s2.h then
            hit = 2
        end if
        if s1.y <= s2.y and s1.y + s1.h >= s2.y + s2.h then 'overlap
            hit = 3
        end if
    end if

    if s1.x + s1.w >= s2.x and s1.x + s1.w <= s2.x+s2.w then
        if s1.y >= s2.y and s1.y <= s2.y + s2.h then
            hit = 4
        end if
    if s1.y + s1.h >= s2.y and s1.y + s1.h <= s2.y+s2.h then
        hit = 5
    end if
        if s1.y <= s2.y and s1.y + s1.h >= s2.y + s2.h then  'overlap
            hit = 6
        end if   
    end if

    return hit

end function


dim shared frog as sprite

dim shared car(1 to 4) as sprite

dim shared logs(1 to 4) as sprite

cls
'create a frog image
dim as uinteger v
for j as integer = 0 to 22
    for i as integer = 0 to 20
        read v
        pset (i,j),v
    next i
next j
dim as FB.Image ptr iFrog = imagecreate(21,23,0)
get (0,0)-(20,22), iFrog

'create a car/truck whatever
dim as FB.Image ptr iCar = imagecreate(40,20,0)
line (0,0)-(39,19),rgb(255,100,0),bf
get (0,0)-(39,19), iCar

'create a log
dim as FB.Image ptr iLogs = imagecreate(60,20,0)
line (0,0)-(59,19),rgb(128,0,0),bf
get (0,0)-(59,19),iLogs

bload "C:\FreeBasic\bitmaps\sprites\backGround.bmp"
'draw background
line (0,0)-(372,31),rgb(255,128,0),bf      'orange display area
line (0,32)-(372,62),rgb(0,128,0),bf       'green home
line (0,63)-(372,191),rgb(128,255,255),bf  'blue river
line (0,192)-(372,223),rgb(0,128,0),bf     'green safe spot
line (0,224)-(372,351),rgb(192,192,192),bf 'gray road
line (0,352)-(372,383),rgb(0,128,0),bf     'green start
line (0,384)-(372,415),rgb(255,128,0),bf   'orange display area
for i as integer = 0 to 5
        circle (i*62+31,47),12,rgb(128,0,0),,,,f 'frog holes
next i
'lines on road
line (0,256)-(372,256),rgb(255,255,0)  'yellow lines
line (0,288)-(372,288),rgb(255,255,0)
line (0,320)-(372,320),rgb(255,255,0)


'display text
locate 2,1
color rgb(0,0,0),rgb(255,128,0)  'black on orange
print "   FROGGER GAME   "

dim as FB.Image ptr backGround = imagecreate(372,416,0)
get (0,0)-(371,415),backGround

dim as string reply

do
    reply = ""  'signal to keep going while reply <> "y" or "x"
    frog.x=170
    frog.y=357
    frog.w=21
    frog.h=23
    frog.speed=32

    car(1).x = 0
    car(1).y = 230
    car(1).dx = 1
    car(1).dy = 0
    car(1).w = 40
    car(1).h = 20

    car(2).x = 300
    car(2).y = 262
    car(2).dx = 1
    car(2).dy = 0
    car(2).w = 40
    car(2).h = 20

    car(3).x = 150
    car(3).y = 294
    car(3).dx = 1
    car(3).dy = 0
    car(3).w = 40
    car(3).h = 20

    car(4).x = 30
    car(4).y = 326
    car(4).dx = 1
    car(4).dy = 0
    car(4).w = 40
    car(4).h = 20

    logs(1).x = 0
    logs(1).y = 72
    logs(1).dx = 1
    logs(1).dy = 0
    logs(1).w = 60
    logs(1).h = 20

    logs(2).x = 300
    logs(2).y = 104
    logs(2).dx = 1
    logs(2).dy = 0
    logs(2).w = 60
    logs(2).h = 20

    logs(3).x = 150
    logs(3).y = 136
    logs(3).dx = 1
    logs(3).dy = 0
    logs(3).w = 60
    logs(3).h = 20

    logs(4).x = 30
    logs(4).y = 168
    logs(4).dx = 1
    logs(4).dy = 0
    logs(4).w = 60
    logs(4).h = 20

    dim as integer chosenLog
    chosenLog = 0

    dim as double now
    now = 0

    do
        screenlock()

        cls
        'draw background
        put (0,0),backGround,pset

        'draw logs under frog
        for i as integer = 1 to 4
            put (logs(i).x, logs(i).y ), iLogs, trans
        next i

        'draw dead frog if speed = 0 else draw live frog
        if frog.speed = 0 then
            'put (frog.x,frog.y),iFrog,trans  'change to a dead frog sprite later
            rotozoom( ,iFrog, frog.x+iFrog->Width\2, frog.y+iFrog->Height\2, int(frog.angle), frog.jump, frog.jump)
        else
            'put (frog.x,frog.y),iFrog, trans
            rotozoom( ,iFrog, frog.x+iFrog->Width\2, frog.y+iFrog->Height\2, int(frog.angle), frog.jump, frog.jump)
        end if

        'draw cars on top of frog
        for i as integer = 1 to 4
            put (car(i).x, car(i).y ), iCar, trans
        next i

        locate 50,1
        if frog.speed = 0 then
            print "  ****  FROG DEAD  ****"
        end if
        if frog.y < 64 then
            print "  ****  FROG HOME  ****"
        end if

        print " HIT SPACE KEY to start again OR ESC key to END program"
        
        screenunlock()

        'update car positions
        for i as integer = 1 to 4
            car(i).x = car(i).x + car(i).dx
        next i

        'update log positions
        for i as integer = 1 to 4
            logs(i).x = logs(i).x + logs(i).dx
           'update frog.x position if on log
            if chosenLog = i then
                frog.x = frog.x + logs(i).dx
            end if
        next i

        'reverse car directions if out of bounds
        for i as integer = 1 to 4
            if car(i).x < 0 or car(i).x > 332 then car(i).dx=-car(i).dx
        next i

        'reverse logs directions if out of bounds
        for i as integer = 1 to 4
            if logs(i).x < 0 or logs(i).x > 312 then logs(i).dx=-logs(i).dx
        next i
        
        'for the frog rotation animation
        frog.angle+=(frog.target_angle-frog.angle)/5
        frog.jump-=.1
        if frog.jump<1 then frog.jump = 1

        'user input accepted only every 0.25 seconds - feels like the real thing
        if timer > (now + 0.25) then

            if multikey(SC_SPACE) then reply = "y"
            if multikey(SC_ESCAPE) then reply = "x"

            if frog.y > 63 then  'test frog hasn't reached home
                if multikey(SC_DOWN) andalso frog.y <352 then
                    frog.y = frog.y+frog.speed
                    frog.target_angle = 180
                    frog.jump=1.5
                    now = timer
                    chosenLog=0
                end if

                if multikey(sc_up)  then
                    
                    'this fixes the rotation error when the target angle is 0, but the current angle is 270
                    if frog.target_angle=270 then
                        frog.angle = -90
                    end if

                    frog.y = frog.y-frog.speed
                    frog.target_angle = 0
                    frog.jump=1.5
                    now = timer   'reset timer
                    chosenLog = 0 'if log remove log ID
                end if

                if multikey(SC_right) andalso frog.x < 302 then

                    'this fixes the rotation jump when the target angle is 270, but the current angle = 0
                    if frog.target_angle = 0 then
                        frog.angle = 360
                    end if

                    frog.x = frog.x+frog.speed
                    frog.target_angle = 270
                    frog.jump=1.5
                    now = timer
                    chosenLog=0
                end if

                if multikey(sc_left) andalso  frog.x > 10  then
                    frog.x = frog.x-frog.speed
                    frog.target_angle = 90
                    frog.jump=1.5
                    now = timer   
                    chosenLog = 0
                end if
            end if

        end if

        dim as integer hit

        if frog.y < 352 and frog.y > 224 then
            'test for collision with car
            hit = 0
            for i as integer = 1 to 4
                if hit = 0 then
                    hit = scollision(frog,car(i))
                end if
            next i

            if hit <> 0 then
                frog.speed = 0  'flag frog dead
            end if

        end if

        if frog.y < 192 and frog.y > 64 then
            'test collision with a log
             hit = 0
            for i as integer = 1 to 4

                hit = scollision(frog,logs(i))

                if hit <> 0 and chosenLog = 0  then
                    chosenLog = i
                end if

            next i

            if  chosenLog=0 then
                locate 1,1
                print "MISSED LOG"
                frog.speed = 0
                sleep
            end if

        end if

        sleep 10, 1

    loop while reply <> "y" and reply <> "x"

loop while reply = "y"

end

'frog image 21 x 23
DATA &HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF
DATA &HFFFF00FF,&HFFFF00FF,&HFF000000,&HFF000000,&HFF000000,&HFFFF00FF,&HFFFF00FF
DATA &HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF
DATA &HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFF000000,&HFF000000
DATA &HFF000000,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF000000
DATA &HFF000000,&HFF000000,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF
DATA &HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFF000000,&HFFFFC90E,&HFF000000
DATA &HFF000000,&HFFFFC90E,&HFF000000,&HFF22B14C,&HFF000000,&HFFFFC90E,&HFF000000
DATA &HFF000000,&HFFFFC90E,&HFF000000,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF
DATA &HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFF000000,&HFFFFC90E,&HFF000000
DATA &HFF000000,&HFFFFC90E,&HFF000000,&HFF22B14C,&HFF000000,&HFFFFC90E,&HFF000000
DATA &HFF000000,&HFFFFC90E,&HFF000000,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF
DATA &HFFFF00FF,&HFF000000,&HFF000000,&HFFFF00FF,&HFF000000,&HFFFFC90E,&HFFFFC90E
DATA &HFFFFC90E,&HFFFFC90E,&HFF000000,&HFF22B14C,&HFF000000,&HFFFFC90E,&HFFFFC90E
DATA &HFFFFC90E,&HFFFFC90E,&HFF000000,&HFFFF00FF,&HFF000000,&HFF000000,&HFFFF00FF
DATA &HFF000000,&HFF22B14C,&HFF22B14C,&HFF000000,&HFFFF00FF,&HFF000000,&HFF000000
DATA &HFF000000,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF000000
DATA &HFF000000,&HFF000000,&HFFFF00FF,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF000000
DATA &HFFFF00FF,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF000000,&HFF22B14C
DATA &HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C
DATA &HFF22B14C,&HFF000000,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF000000,&HFFFF00FF
DATA &HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF000000
DATA &HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C
DATA &HFF000000,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000
DATA &HFFFF00FF,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF000000
DATA &HFF000000,&HFF000000,&HFF22B14C,&HFF000000,&HFF22B14C,&HFF000000,&HFF000000
DATA &HFF000000,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFFFF00FF
DATA &HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000
DATA &HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C
DATA &HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000
DATA &HFFFF00FF,&HFF000000,&HFF000000,&HFF000000,&HFF22B14C,&HFF000000,&HFF22B14C
DATA &HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C
DATA &HFF22B14C,&HFF000000,&HFF22B14C,&HFF000000,&HFF000000,&HFF000000,&HFFFF00FF
DATA &HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFF000000,&HFF000000,&HFF22B14C
DATA &HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C
DATA &HFF22B14C,&HFF000000,&HFF000000,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF
DATA &HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFF000000,&HFF22B14C,&HFF22B14C
DATA &HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C
DATA &HFF22B14C,&HFF22B14C,&HFF000000,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF
DATA &HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFF000000,&HFF22B14C,&HFF22B14C
DATA &HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C
DATA &HFF22B14C,&HFF22B14C,&HFF000000,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF
DATA &HFFFF00FF,&HFF000000,&HFF000000,&HFF000000,&HFF000000,&HFF22B14C,&HFF22B14C
DATA &HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C
DATA &HFF22B14C,&HFF22B14C,&HFF000000,&HFF000000,&HFF000000,&HFF000000,&HFFFF00FF
DATA &HFFFF00FF,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF22B14C
DATA &HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C
DATA &HFF22B14C,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFFFF00FF
DATA &HFFFF00FF,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000
DATA &HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C
DATA &HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFFFF00FF
DATA &HFFFF00FF,&HFF000000,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000
DATA &HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C
DATA &HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF000000,&HFFFF00FF
DATA &HFFFF00FF,&HFFFF00FF,&HFF000000,&HFF22B14C,&HFF000000,&HFF22B14C,&HFF22B14C
DATA &HFF000000,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF000000
DATA &HFF22B14C,&HFF22B14C,&HFF000000,&HFF22B14C,&HFF000000,&HFFFF00FF,&HFFFF00FF
DATA &HFFFF00FF,&HFF000000,&HFF000000,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C
DATA &HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000
DATA &HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF000000,&HFF000000,&HFFFF00FF
DATA &HFFFF00FF,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF000000
DATA &HFF22B14C,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF22B14C
DATA &HFF000000,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFFFF00FF
DATA &HFFFF00FF,&HFF000000,&HFF000000,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF000000
DATA &HFF000000,&HFF000000,&HFF22B14C,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF000000
DATA &HFF000000,&HFF22B14C,&HFF22B14C,&HFF000000,&HFF000000,&HFF000000,&HFFFF00FF
DATA &HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFF000000,&HFF000000,&HFF000000
DATA &HFFFF00FF,&HFFFF00FF,&HFF000000,&HFF000000,&HFF000000,&HFFFF00FF,&HFFFF00FF
DATA &HFF000000,&HFF000000,&HFF000000,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF,&HFFFF00FF
